#include "ContainerTest.h"

#include "factory/StringDataFactory.hpp"

#include <container/string/ObjectsVariant.h>
#include <primitive/string/Integer.h>
#include <primitive/string/String.h>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( ContainerTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( ContainerTest );

void ContainerTest::setUp() {
}

void ContainerTest::tearDown() {
}

void ContainerTest::VariantTest() {
	std::string input1 = "1";
	ext::variant < int, std::string > variant1 = factory::StringDataFactory::fromString ( input1 );

	std::string output1 = factory::StringDataFactory::toString ( variant1 );

	std::cout << "\"" << input1 << "\"" << std::endl << std::endl << "\"" << output1 << "\"" << std::endl;
	CPPUNIT_ASSERT( input1 == output1 );

	ext::variant < int, std::string > variant2 = factory::StringDataFactory::fromString ( output1 );

	CPPUNIT_ASSERT( variant1 == variant2 );
	CPPUNIT_ASSERT ( variant2.template get < int > ( ) == 1 );

	std::string input2 = "aa";
	ext::variant < int, std::string > variant3 = factory::StringDataFactory::fromString ( input2 );

	CPPUNIT_ASSERT ( variant3.template get < std::string > ( ) == "aa" );
}

